/* WWW CGI Blackjack player  -- Henry Minsky (hqm@ai.mit.edu) 
 *
 * $Header: /usr/local/etc/httpd/htdocs/FreeSoft/blackjack/RCS/bjcount.c,v 1.7 1996/01/18 05:14:45 baccala Exp baccala $
 *
 * This program is the property of Universal Access Inc. 
 *
 *     Copyright (C) 1994 Henry Minsky
 *     
 *     This program is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU General Public License
 *     as published by the Free Software Foundation; either version 2
 *     of the License, or (at your option) any later version.
 *     
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *     
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * */



#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <sys/time.h>
int gettimeofday(struct timeval *, struct timezone *);

#include "bj.h"


#define TRUE 1
#define FALSE 0

#define BJ_URL "playbj.cgi"
#define CARDS_URL "images"
#define CHIPS_URL "images"
#define UP_GIF_FILE "images/up.gif"
#define strerror(x) sys_errlist[x]

#define ChipImageWidth 78
#define ChipImageHeight 70
#define CardImageWidth 79
#define CardImageHeight 123


int dealerStands = 17;
int UserBet = 100;

int nDecks;

Deck *theDeck;
int reshuffle = FALSE;

Player player;
Player dealer;

Deck baseDeck =
{
  52, /* ncards */
  51, /* top card */
  0,  /* shuffled? */
  {
    { ACE, CLUBS },
    { TWO, CLUBS },
    { THREE, CLUBS },
    { FOUR, CLUBS },
    { FIVE, CLUBS },
    { SIX, CLUBS },
    { SEVEN, CLUBS },
    { EIGHT, CLUBS },
    { NINE, CLUBS },
    { TEN, CLUBS },
    { JACK, CLUBS },
    { QUEEN, CLUBS },
    { KING, CLUBS },

    { ACE, SPADES },
    { TWO, SPADES },
    { THREE, SPADES },
    { FOUR, SPADES },
    { FIVE, SPADES },
    { SIX, SPADES },
    { SEVEN, SPADES },
    { EIGHT, SPADES },
    { NINE, SPADES },
    { TEN, SPADES },
    { JACK, SPADES },
    { QUEEN, SPADES },
    { KING, SPADES },

    { ACE, HEARTS },
    { TWO, HEARTS },
    { THREE, HEARTS },
    { FOUR, HEARTS },
    { FIVE, HEARTS },
    { SIX, HEARTS },
    { SEVEN, HEARTS },
    { EIGHT, HEARTS },
    { NINE, HEARTS },
    { TEN, HEARTS },
    { JACK, HEARTS },
    { QUEEN, HEARTS },
    { KING, HEARTS },

    { ACE, DIAMONDS },
    { TWO, DIAMONDS },
    { THREE, DIAMONDS },
    { FOUR, DIAMONDS },
    { FIVE, DIAMONDS },
    { SIX, DIAMONDS },
    { SEVEN, DIAMONDS },
    { EIGHT, DIAMONDS },
    { NINE, DIAMONDS },
    { TEN, DIAMONDS },
    { JACK, DIAMONDS },
    { QUEEN, DIAMONDS },
    { KING, DIAMONDS }
  }
};

StateMap state_name_table[] = 
{
  {IN_PLAY, "PLY"},
  {BUST, "BST"},
  {CLOSED, "CLS"},
  {WON, "WON"},
  {LOST, "LST"},
  {PUSH, "PSH"},
  {SURRENDERED, "SUR"},
  {SPLIT_PAIR, "SPLT"},
  {DOUBLED, "DBL"},
  {BLACKJACK, "BJK"}
};


StateMap pretty_state_name_table[] = 
{
  {IN_PLAY, "IN PLAY"},
  {BUST, "BUST"},
  {CLOSED, "STAND"},
  {WON, "WON"},
  {LOST, "LOST"},
  {PUSH, "PUSH"},
  {SURRENDERED, "SURRENDER"},
  {SPLIT_PAIR, "SPLIT_PAIR"},
  {DOUBLED, "DOUBLED"},
  {BLACKJACK, "BLACKJACK"}
};

MoveMap move_name_table[] =
{
  {IDLE, "IDL"},
  {STAND, "STD"},
  {HIT, "HIT"},
  {SPLIT, "SPL"},
  {DOUBLE, "DBL"},
  {SURRENDER, "SDR"}
};



ValueMap value_name_table[] = 
{ 
  {_NOVAL_, 'X'}, 
  {ACE, 'A'}, 
  {TWO, '2'}, 
  {THREE, '3'}, 
  {FOUR, '4'}, 
  {FIVE, '5'}, 
  {SIX, '6'}, 
  {SEVEN, '7'}, 
  {EIGHT, '8'}, 
  {NINE, '9'}, 
  {TEN, 'T'}, 
  {JACK, 'J'}, 
  {QUEEN, 'Q'},
  {KING, 'K'}
};


SuitMap suit_name_table[] =
{
  {_NOSUIT_, 'X'},
  {CLUBS, 'C'}, 
  {DIAMONDS, 'D'}, 
  {HEARTS, 'H'}, 
  {SPADES, 'S'}
 };


void init_player(Player *p)
{
  p->nhands       = 0;
  p->balance      = 1000;
  p->hands_closed = 0;
  p->options      = strdup("XYZW");
  p->seqnum = 0;
  p->ndealt = 0;
  p->seed  = 0;
  p->bet = UserBet;
  p->orig_balance = p->balance;
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * name:	theCount
 * purpose:	count cards which have been dealt
 * inputs:
 *  Deck *deck
 * returns:
 *
 * remarks
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int
theCount (Deck *deck)
{
  int n;
  int count = 12;
  int v;
  Card c;


  for (n = ((deck->n) + 1) ; n < deck->ncards; n++)
    {
      c = deck->cards[n];

      v = card_value_hard(c);
      if ( (v == 10) | (v == 1)) 
	{ count--; } 
      else if ((v == 2) ||
	      (v == 3) ||
	      (v == 4) ||
	      (v == 5) ||
	      (v == 6))
	{ count++; } 
    }

  return count;
}



void print_header(FILE *f)
{
  /* Just for fun -- see if there is a special message for this user */
  char *remote_host;
  char *remote_addr;
  char tmpnam[1024];
  char buf[1024];

  FILE *msg;

  remote_host = getenv("REMOTE_HOST");
  remote_addr = getenv("REMOTE_ADDR");

  fprintf(f, "<HTML>\n");
  fprintf(f, "<TITLE>The FreeSoft Casino</TITLE>\n");
  fprintf(f, "<HEAD>\n");
  fprintf(f, "<H2>The FreeSoft Casino</H2>\n");
  fprintf(f, "</HEAD>\n");
  fprintf(f, "<BODY>\n");
  fprintf(f, "\n");

  msg = NULL;
  if (remote_host != NULL)
    {
      sprintf(tmpnam, "/tmp/BJ.%s", remote_host);
      msg = fopen(tmpnam, "r");
    }
  else if (remote_addr != NULL)
    {
      sprintf(tmpnam, "/tmp/BJ.%s", remote_addr);
      msg = fopen(tmpnam, "r");
    }
  if (msg != NULL)
    {
      int val;

      fprintf(f,"<h3>\n");
      while (fgets(buf, sizeof(buf), msg) != NULL)
	fprintf(f, "%s", buf);
      fprintf(f, "\n</h3>\n");
      fclose(msg);
      val = unlink(tmpnam);
      if (val < 0)
	fprintf (f, "<pre>[unlink = %d %s :-)]</pre>\n", val, strerror(errno));
    }

}

/* Print a link which carries the balance player balance forward.
 * We give the option of bets of 20, 40, 50, 100, 200
*/

void format_bets(Player *p, FILE *f)
{
  int i;
  int bets[] = {1,2,5,10,25,50,75,100,200,300,400,500};
  int n;

  n =  sizeof(bets)/sizeof(int);
  fprintf(f, "BET ");
  for (i = 0; i < n; i++)
    {
      fprintf(f, "<A HREF=\"%s?", BJ_URL);
      fprintf(f, "%s@", p->options);
      fprintf(f, "%d@", p->seqnum);
      fprintf(f, "%d@", theDeck->ncards - (theDeck->n + 1));
      fprintf(f, "%d@", p->seed);
      fprintf(f, "%d@", bets[i]);
      fprintf(f, "%d@", p->balance);
      fprintf(f, "\">$%d</A>", bets[i] );
      if (i < n-1) fprintf(f, ", ");
    }
}


void format_new_game(Player *p, FILE *f)
{
  int i;
  int bets[] = {1,2,5,10,25,50,75,100,200,300,400,500};
  int n;

  n =  sizeof(bets)/sizeof(int);
  fprintf(f, "<H2> Play Another Hand?</H2>  Your new bet is ");
  for (i = 0; i < n; i++)
    {
      p->bet =  bets[i];

      fprintf(f, "<A HREF=\"%s?", BJ_URL);
      fprintf(f, "%s@", p->options);
      fprintf(f, "%d@", p->seqnum);
      fprintf(f, "%d@", theDeck->ncards - (theDeck->n + 1));
      fprintf(f, "%d@", p->seed);
      fprintf(f, "%d@", p->bet);
      fprintf(f, "%d@", p->balance);
      fprintf(f, "\">$%d</A>", p->bet );
      if (i < (n-1)) fprintf(f, ", ");

    }

}

/* Starter hand of blackjack */
void make_starter_hand(Player *p)
{
  Hand *dh, *h;

  /* Deal two cards to the dealer, but set dh->ncards so it
   * only looks like one has been dealt.  If the dealer was
   * dealt a blackjack, note this.
   */

  dh = &(dealer.hands[0]);

  p->dealer_upcard = deal_card(dh, theDeck);
  p->dealer_holecard = deal_card(dh, theDeck);

  evaluate_hand(dh);
  if (dh->state != BLACKJACK) {
    dh->state = IN_PLAY;
    dh->ncards = 1;
  }


  /* Start the user off with a hand with two cards */
  p->nhands = 1;
  h = &(p->hands[0]);

  deal_card(h, theDeck);
  deal_card(h, theDeck);

  h->bet = p->bet;

  h->move = IDLE;
  h->state = IN_PLAY;
  evaluate_hand(h);

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * name:	randomize
 * purpose:	Initializes the random number generator
 * inputs:
 *   int seed
 *   int genseed   if TRUE, generate new random seed else
 *                 use SEED arg.
 * returns:
 *  The seed, useful if generating a seed
 * remarks
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int
randomize(int seed, int genseed)
{

  struct timeval tp;
  gettimeofday(&tp, NULL);
  if (genseed == TRUE)
    {
      seed = tp.tv_usec*tp.tv_sec;
    }
  
  srandom(seed);

  return (seed);
}

/* Read a hand state-vector from stdin, which is contained in one line.
   Return a new state vector for each one.  */

/* The state vector has been precomputed to have only one play per
   hand. */

/* "SEQ@NCARDS@SEED@1000@IN_PLAY@STAND@10@0@AH@3D@7S@8S@_@IN_PLAY@SPLIT@10@0@AH@9D@9S@" */
int main ()
{
  char *query;

  reshuffle = FALSE;
  nDecks = 6;
  
  init_player(&player);
  init_player(&dealer);

  theDeck = new_deck(nDecks);

  fprintf(stdout, "Content-type: text/html%c%c",10,10);  

  /* Get the player state vector */
  query = getenv("QUERY_STRING");


  if (query == NULL || !strcmp(query, "")) 
    {
      /* Generate a new random seed */
      player.seed = randomize(0, TRUE);
    }
  else if (!strcmp (query, "BJCC") && (strlen(query) == 4))
    {
      player.seed = randomize(0, TRUE);
      player.options = "BJCC";
    }
  else
    {
      plustospace(query);

      parse_hand(&player, query);
      randomize(player.seed, FALSE);

      /* Increment the sequence number,so that viewers don't cache any pages */
      player.seqnum++;
    }


  /* remove any already dealt cards -- we do this by using the fact
   * that the random number generator is deterministic w.r.t. the seed
   * so we can remove all cards dealt so far in previous hands. 
   */
  
  shuffle_deck(theDeck);
  /* Remove the dealt cards */
  theDeck->n -= player.ndealt;


  /* The user wants a new game, but with their balance carried over */
  if ( (player.nhands == 0) || (query == NULL) || !strcmp(query, "")) 
    {
      make_starter_hand(&player);
    }

  print_header(stdout);

  evaluate_player(&player);

  format_next_move(&player, stdout); 

  fprintf(stdout, "<HR>\n");  
  fprintf(stdout, "<A HREF=\"..\"> <IMG SRC=\"%s\"></A> 
    <A HREF=\"..\"> Return </A> to the FreeSoft home page.\n", UP_GIF_FILE);

  fprintf(stdout, "<P>This blackjack server is based on\n");  
  fprintf(stdout, "<A HREF=\"http://www.ua.com/\">Universal Access Inc</A>'s Blackjack Engine.\n");
  fprintf(stdout, "Copyright &#169; 1995\n");
  fprintf(stdout, "<P>Local modifications by FreeSoft.\n");

  fprintf(stdout, "</BODY>\n");
  fprintf(stdout, "</HTML>\n");

  exit(0);
}


/****************************************************************
 * name:	format_next_move
 * purpose:	Take the current state of player and dealer
 *              and format a HTML page which has links for the next 
 *              possible moves. 
 * inputs:
 *  Player *p
 *  FILE *out   output stream
 * returns:
 *
 * remarks
 *  Currently, no forms support, so every
 *  link is a new move.
 ****************************************************************/

void  format_next_move(Player *p, FILE *out)
{
  /* If all hands done, then format the final tally page. */
  if (p->hands_closed == TRUE)
    {
      /* We shuffle when we get down to one deck */
      if (player.ndealt > ((nDecks - 1) * 52))
	{
	  int balance;
	  /* save player's balance */
	  balance = player.balance;

	  /* start a new deck */
	  player.ndealt = 0;
	  reshuffle = TRUE;

	  /* Make a new deck (really just need to reset deck->n to
             ncards...)*/
	  theDeck = new_deck(nDecks);

	  /* Generate a new random seed */
	  player.seed = randomize(0, TRUE);
	  fprintf(stdout, "<H2>This shoe is over, SHUFFLING</H2>\n");  
	}

      format_final_page(p, out);
    }
  else
    {
      format_next_page(p, out);
    }
}


void format_table (Player *p, FILE *out)
{
  int bet_on_hand;
  int balance_less_bets;
  int action_list_printed = FALSE;
  Hand *h;
  Hand *dh;
  int i;

  dh = &(dealer.hands[0]);

  balance_less_bets = p->balance;

  fprintf(out, "<TABLE>\n");

  /* First row is dealer hand */

  fprintf(out, "<TR><TH><TH ALIGN=CENTER>Dealer\n");

  fprintf(out, "<TR><TD><TD ALIGN=CENTER>");
  format_cards(dh, out);

  /* Third row is betting options */
  if (dh->state != IN_PLAY) {
    fprintf(out, "<TD>");
    format_bets(p, out);
  }

#ifdef SHOW_CARD_NAMES
  fprintf(out, "<TR><TD><TD ALIGN=CENTER>");

  for (i = 0; i < h->ncards; i++)
    {
      fprintf(out, "%s", pretty_format_card(h->cards[i]));
      if (i < h->ncards-1) fprintf(out, "<BR>");
    }
#endif



  /* Format each row */
  for (i = 0; i < p->nhands; i++) 
    {
      h =  &(p->hands[i]);

      if (p->nhands == 1)
	fprintf(out, "<TR><TH><TH ALIGN=CENTER>Player\n");
      else
	fprintf(out, "<TR><TH><TH ALIGN=CENTER>Player - Hand %d\n", i+1);

      /* First column - bet in chips */

      fprintf(out, "<TR><TD>");

      if (h->aux == DOUBLED) bet_on_hand = p->bet*2;
      else                   bet_on_hand = p->bet;

      switch (h->state) {
      case IN_PLAY:
      case CLOSED:
      case PUSH:
	format_chips(out, bet_on_hand);
	balance_less_bets -= bet_on_hand;
	break;

      case BUST:
      case LOST:
	break;

      case SURRENDERED:
	format_chips(out, bet_on_hand/2);
	balance_less_bets -= bet_on_hand/2;
	break;

      case WON:
	format_chips(out, bet_on_hand*2);
	balance_less_bets -= bet_on_hand*2;
	break;

      case BLACKJACK:
	format_chips(out, bet_on_hand*5/2);
	balance_less_bets -= bet_on_hand*5/2;
	break;

      default:
	fprintf(out, "Can't figure out hand state %d\n", h->state);
	break;
      }

      /* Second column - the cards */

      fprintf(out, "<TD ALIGN=CENTER>");
      format_cards(h, out);

      /* Third column - options */

      fprintf(out, "<TD>");
      if (h->state == IN_PLAY && !action_list_printed) {
	format_hand_options(p, h, out);
	action_list_printed = TRUE;
      }
    }
  fprintf(out, "</TABLE>\n");

  format_chips(out, balance_less_bets);
}


/* typedef enum { IN_PLAY, BUST, CLOSED, WON, LOST, PUSH, 
		 BLACKJACK } State;
*/

void format_final_page (Player *p, FILE *out)
{
  if (!strcmp (p->options, "BJCC"))
    {
      fprintf(out, "[<a href=/count=%d>%.2f decks remaining</a>]<BR>\n", 
	      theCount (theDeck),
	      nDecks * (((float) theDeck->n) / ((float) theDeck->ncards))
	      );
    }
  else
    {
      fprintf(out, "[%.2f decks remaining]<BR>\n", 
	      nDecks * (((float) theDeck->n) / ((float) theDeck->ncards))
	      );
    }

  format_table(p, out);
}


/* Computes the final payoffs for each hand of a player.
   
   Compare each hand to the dealer hand.
   If dealer is BUST, assign win to every hand which is not BUST 
   
   Pay off blackjacks 3 to 2.

   */

void evaluate_final_hand(Player *p)
{
  Hand *h;
  Hand *dh;
  int i;

  dh = &(dealer.hands[0]);

  /* For each hand ... */
  for (i=0; i < p->nhands; i++)
    {
      h = &(p->hands[i]);

      /* If player is bust, they lose their bet. */
      if (h->state == BUST)
	{
	  p->balance -= h->bet;
	  break;
	}

      if (h->state == SURRENDERED)
	{
 	  p->balance -= h->bet/2;
 	  break;
 	}

      /* If dealer is bust, and player is not bust, player wins. */
      if (dh->state == BUST) 
	{
	  /* Blackjack pay off 3 to 2 */
	  if (h->state == BLACKJACK)
	    {
	      p->balance += ((3 * h->bet) / 2);
	    }
	  else
	    {
	      p->balance += h->bet;
	      h->state = WON;
	    }

	}
      else
	{
	  /* If dealer is not bust, compare values with player hand. */
	  if (dh->value == h->value)
	    {
	      /* Blackjack beats dealer draw to 21 */
	      if ( (h->state == BLACKJACK) && (dh->state != BLACKJACK))
		{ 
		  if (h->state == BLACKJACK)
		    {
		      p->balance += ((3 * h->bet) / 2);
		    }
	      
		} 
	      /* If dealer has Blackjack, and player doesn't, dealer wins. */
	      else if ( (h->state != BLACKJACK) && (dh->state == BLACKJACK))
		
		{
		  h->state = LOST;
		  p->balance -= h->bet;
		}
	      else
		{
		  h->state = PUSH;
		}


	    } 
	  else if (dh->value > h->value)
	    {
	      h->state = LOST;

	      p->balance -= h->bet;

	    } 
	  else 
	    {
	      if (h->state == BLACKJACK)
		{
		  p->balance += ((3 * h->bet) / 2);
		}
	      else
		{
		  h->state = WON;
		  p->balance += h->bet;
		}

	    }
	}
	
    }
}





/* print:
   balance
   dealer_upcard 
   hand1 hand1-options
   ...
   */

void format_next_page(Player *p, FILE *out)
{
  fprintf(out, "Balance = $%d, Bet = $%d ", p->balance, p->bet);

  if (!strcmp (p->options, "BJCC"))
    {
      fprintf (out, " [<a href=/count=%d>%.2f decks remaining</a>]<BR>\n", 
	       theCount (theDeck),
	       nDecks * (((float) theDeck->n) / ((float) theDeck->ncards))
	       );
    } 
  else
    {
      fprintf (out, " [%.2f decks remaining]<BR>\n", 
	       nDecks * (((float) theDeck->n) / ((float) theDeck->ncards))
	       );
    }

  format_table(p, out);
}


void format_chips(FILE *out, int amount)
{
  int nchips;

  while (amount > 500) {
    fprintf(out, "<IMG SRC=\"%s/black5.gif\" WIDTH=%d HEIGHT=%d>",
	    CHIPS_URL, ChipImageWidth, ChipImageHeight);
    amount -= 500;
  }

  while (amount >= 100) {
    nchips = (amount/100)%5;
    if (nchips == 0) nchips=5;
    fprintf(out, "<IMG SRC=\"%s/black%1d.gif\" WIDTH=%d HEIGHT=%d>",
	    CHIPS_URL, nchips, ChipImageWidth, ChipImageHeight);
    amount -= 100*nchips;
  }

  while (amount  >= 25) {
    nchips = (amount/25)%5;
    if (nchips == 0) nchips=5;
    fprintf(out, "<IMG SRC=\"%s/green%1d.gif\" WIDTH=%d HEIGHT=%d>",
	    CHIPS_URL, nchips, ChipImageWidth, ChipImageHeight);
    amount -= 25*nchips;
  }

  while (amount  >= 5) {
    nchips = (amount/5)%5;
    if (nchips == 0) nchips=5;
    fprintf(out, "<IMG SRC=\"%s/red%1d.gif\" WIDTH=%d HEIGHT=%d>",
	    CHIPS_URL, nchips, ChipImageWidth, ChipImageHeight);
    amount -= 5*nchips;
  }

  if (amount > 0)
    fprintf(out, "<IMG SRC=\"/blackjack/blue%1d.gif\" WIDTH=%d HEIGHT=%d>",
	    amount, ChipImageWidth, ChipImageHeight);

}



void format_cards(Hand *h, FILE *out)
{
  int i;

  for (i = 0; i < h->ncards; i++)
    {
      fprintf(out, "%s\n",  card_inline_image(h->cards[i]));
    }

  if (i == 1)
    fprintf(out, "<IMG SRC=\"/blackjack/images/back.gif\" WIDTH=%d HEIGHT=%d>\n", CardImageWidth, CardImageHeight);

}


/* Print the cards in the hand, and any possible options as formatted links.
 * 
 */
void format_hand(Player *p, Hand *h, FILE *out, int chips)
{
  int i;


  for (i = 0; i < h->ncards; i++)
    {
      fprintf(out, "%s\n",  card_inline_image(h->cards[i]));
    }

  if (i == 1) fprintf(out, "<IMG SRC=\"/blackjack/images/back.gif\" WIDTH=%d HEIGHT=%d>\n", CardImageWidth, CardImageHeight);

  if (h->state == IN_PLAY && chips > 0)
    {
      format_hand_options(p, h, out);
    }

  fprintf(out, "<TR>\n    <TD><TD ALIGN=CENTER>");

  for (i = 0; i < h->ncards; i++)
    {
      fprintf(out, "%s", pretty_format_card(h->cards[i]));
      if (i < h->ncards-1) fprintf(out, "<BR>");
    }

}

/****************************************************************
 * name:	is_ten
 * purpose:	Predicate tests if cards has a value of 10
 * inputs:
 *  Value v
 * returns:
 * TRUE or FALSE
 * remarks
 ****************************************************************/
int is_ten(Value v)
{
  return( (v == TEN) || (v == JACK) || (v == QUEEN) || (v == KING));
}



/****************************************************************
 * name:	can_double
 * purpose:	Predicate which tells if you are allowed to double on this hand
 * inputs:
 * Hand *h
 * returns:
 *  TRUE or FALSE
 * remarks
 ****************************************************************/

int can_double(Hand *h)
{
  return ((h->ncards == 2) && !(h->state == BLACKJACK));
}

/*
 * We provide the user with a choice of 20, 50 and 100 dollar bets
 *
 *
 * The user has the option to split a pair.
 *
 * The user has the option to double on 9,10,11, 
 * or A2-7
 *
 */
void
format_hand_options(Player *p, Hand *h, FILE *out)
{

  fprintf(out, "<TD ALIGN=CENTER>");

  /* options are hit, stand, (double, split, surrender) */
  fprintf(out, "<A HREF=\"%s?", BJ_URL);
  h->move = STAND;
  format_hands(p, out);
  h->move = IDLE;
  fprintf(out, "\"> STAND</A> <BR>\n");
 
      
  fprintf(out, "<A HREF=\"%s?", BJ_URL);
  h->move = HIT;
  format_hands(p, out);
  h->move = IDLE;
  fprintf(out, "\"> HIT</A> <BR>\n");

  if (h->ncards == 2) 
    {
      /* Can Split if cards are equal */
      if ( ((h->cards[0]).val == (h->cards[1]).val)
	  || ( is_ten(h->cards[0].val)
	      && is_ten(h->cards[1].val)))
	{
	    fprintf(out, "<A HREF=\"%s?", BJ_URL);
	    h->move = SPLIT;
	    format_hands(p, out);
	    h->move = IDLE;
	    fprintf(out, "\"> SPLIT</A> <BR>\n");
	}

      if (can_double(h))
	{
	    fprintf(out, "<A HREF=\"%s?", BJ_URL);
	    h->move = DOUBLE;
	    format_hands(p, out);
	    h->move = IDLE;
	    fprintf(out, "\"> DOUBLE</A> <BR>\n");
	  
	}

      fprintf(out, "<A HREF=\"%s?", BJ_URL);
      h->move = SURRENDER;
      format_hands(p, out);
      h->move = IDLE;
      fprintf(out, "\"> SURRENDER</A>\n");

    }
}


/****************************************************************
 * name:	evaluate_player
 * purpose:	plays one hand of blackjack.
 * inputs:
 * - Player *p
 * returns:
 *
 * remarks
 * This modifies the players hands to their next state. 
 * If all hands are closed, then we set the hands_closed flag. 
 *
 * We loop over the hands, until we find the one whose move is not IDLE
 *
 * If all hands are idle, set the player hands_closed flag = TRUE, and
 * play out the dealer's hand.
 * 
 ****************************************************************/
/*
typedef enum { IN_PLAY, BUST, CLOSED, WON, LOST, PUSH, DOUBLED
               BLACKJACK } State;
typedef enum { IDLE, STAND, HIT, SPLIT, DOUBLE } Move;
*/
void evaluate_player(Player *p)
{
  int i;
  Hand *h;
  Hand *dh = &(dealer.hands[0]);

  p->hands_closed = TRUE;

  for (i = 0; i < p->nhands; i++)
    {
      h = &(p->hands[i]);

      /* Find a hand which is active (there should be at most one */

      /* Do the requested move. If it is a split, start a new hand */
      /* If the hand is still in play, then we are not done (closed) yet */

      play_hand(p, i);
      if (p->hands[i].state == IN_PLAY)
	p->hands_closed = FALSE;
    }

  /* If all hands are closed or bust, (i.e., no more hands are IN_PLAY)
   * then play the dealer's hand, and see who won which hands.
   */
  if (p->hands_closed == TRUE || dh->state == BLACKJACK)
    {

      play_dealer_hand(p);
      evaluate_final_hand(p);
    } 
}

/* return TRUE if all hands are BUST or BLACKJACK or SURRENDERED */
int all_bust_or_blackjack(Player *p)
{
  int i;
  for (i=0; i < p->nhands; i++)
    {
      if ((p->hands[i].state != BUST) &&
 	  (p->hands[i].state != SURRENDERED) &&
	  (p->hands[i].state != BLACKJACK))
	{
	  return (FALSE);
	}
    }
  return(TRUE);
}

/****************************************************************
 * name:	play_dealer_hand
 * purpose:	
 * inputs:
 * Player *p
 * returns:
 *
 * remarks
 * If player is BUST, show dealer hole card.
 ****************************************************************/
void play_dealer_hand(Player *p)
{

  Hand *dh;

  /* Start the hand with the dealer upcard. */
  dealer.nhands = 1;
  dh = &(dealer.hands[0]);

  init_hand(dh,0);

  dh->ncards = 2;
  dh->cards[0] = p->dealer_upcard;
  dh->cards[1] = p->dealer_holecard;

  if (!all_bust_or_blackjack(p))
    {
      /* dealer stands on variable 'dealerStands'  */
      while (TRUE)
	{
	  evaluate_hand(dh);
	  if (dh->value >= dealerStands) break;

	  deal_card(dh, theDeck);
	}
    } 
  
  evaluate_hand(dh);

  if (dh->state == IN_PLAY)
    {
      dh->state = CLOSED;
    }

  if (dh->value > 21)
    {
      dh->state = BUST;
    }
}

Move basicStratMove(Hand *h, Value upcard)
{

  evaluate_hand(h);

  if (h->ncards == 2 && h->cards[0].val == h->cards[1].val) {
    switch (h->cards[0].val) {
    case ACE:
    case EIGHT:
                                                        return SPLIT;

    case TWO:
    case THREE:
      if (upcard >= FOUR && upcard <= SEVEN)            return SPLIT;
      else                                              return HIT;

    case FOUR:
    case FIVE:
      goto BS_hard_count;

    case SIX:
      if (upcard >= THREE && upcard <= SEVEN)           return SPLIT;
      else                                              return HIT;

    case SEVEN:
      if (upcard >= TWO && upcard <= SEVEN)             return SPLIT;
      else                                              return HIT;

    case NINE:
      if (upcard >= TWO && upcard <= NINE &&
          upcard != SEVEN)                              return SPLIT;
      else                                              return STAND;

    case TEN:
    case JACK:
    case QUEEN:
    case KING:
                                                        return STAND;
    }
  }
  else if (h->softvalue > 0) {
    switch (h->softvalue - 1) {
    case 2:
    case 3:
      if (h->ncards == 2 &&
	  upcard >= FIVE && upcard <= SIX)              return DOUBLE;
      else                                              return HIT;

    case 4:
    case 5:
      if (h->ncards == 2 &&
	  upcard >= FOUR && upcard <= SIX)              return DOUBLE;
      else                                              return HIT;

    case 6:
      if (h->ncards == 2 &&
	  upcard >= THREE && upcard <= SIX)             return DOUBLE;
      else                                              return HIT;

    case 7:
      if (h->ncards == 2 &&
	  upcard >= THREE && upcard <= SIX)             return DOUBLE;
      else if (upcard == SEVEN || upcard == EIGHT)      return STAND;
      else                                              return HIT;

    case 8:
    case 9:
    case 10:
                                                        return STAND;

    }
  }
  else {

BS_hard_count:

    switch (h->value) {
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
                                                        return HIT;

    case 9:
      if (h->ncards == 2 &&
          upcard >= TWO  &&  upcard <= SIX)             return DOUBLE;
      else                                              return HIT;

    case 10:
      if (h->ncards == 2 &&
          upcard >= TWO  &&  upcard <= NINE)            return DOUBLE;
      else                                              return HIT;

    case 11:
      if (h->ncards == 2 && upcard != ACE)              return DOUBLE;
      else                                              return HIT;

    case 12:
      if (upcard >= FOUR && upcard <= SIX)              return STAND;
      else                                              return HIT;


    case 13:
    case 14:
    case 15:
    case 16:
      if (upcard >= TWO && upcard <= SIX)               return STAND;
      else                                              return HIT;

    case 17:
    case 18:
    case 19:
    case 20:
    case 21:
                                                        return STAND;
    }
  }

  return STAND;
}

/****************************************************************
 * name:	play_hand
 * purpose:	Does unit of play, based on user 
 *              requested move.
 * inputs:
 *   Player *p
 *   int nhand  which hand is being played .
 * returns:
 *  
 * remarks: 
 *    Destructively modifies the player's hand.
 *
 ****************************************************************/



void play_hand(Player *p, int nhand)
{
  Card card;
  Hand *h, *sh;

  h = &(p->hands[nhand]);
  /* All hands need to be evaluated at once, to total them up. */
  evaluate_hand(h);


  /* Play annoying Howard Stern noise if user made a mistake.
   *
   * If popen() doesn't work, so what.
   */

  if (h->move != IDLE && h->move != basicStratMove(h, p->dealer_upcard.val))
    popen("/usr/local/bin/play /usr/local/etc/httpd/htdocs/blackjack/mistake.au","r");


  switch (h->move) {
  case STAND:
    h->state = CLOSED;
    break;
  case HIT:
    card = deal_card(h, theDeck);
    evaluate_hand(h);
    break;
  case SPLIT:
    /* Create a new hand with one each of the pair. Remove
       one card from this hand to make the other hand. 
       Deal a new card to each hand.
       */
    sh = &(p->hands[p->nhands++]);
    init_hand(sh, p->bet);
    sh->cards[0] = h->cards[1];
    sh->ncards = 1;
    deal_card(sh, theDeck);

    h->ncards = 1;
    deal_card(h, theDeck);

    h->aux = SPLIT_PAIR;
    sh->aux = SPLIT_PAIR;

    evaluate_hand(h);
    evaluate_hand(sh);

    break;
  case DOUBLE:
    /* Deal one more card, double the bet, and close the hand. */
    card = deal_card(h, theDeck);

    h->aux = DOUBLED;
    h->bet *= 2;

    evaluate_hand(h);
    /* It should not be possible for the hand to be in any state 
     * but IN_PLAY, or BUST, but just to make sure... 
     */
    if (h->state == IN_PLAY)
      { 
	h->state = CLOSED; 
      }
    break;

  case SURRENDER:
    h->state = SURRENDERED;
    evaluate_hand(h);

  case IDLE:
    break;
  }

  h->move = IDLE;

}


/****************************************************************
 * name:	new_deck
 * purpose:	
 * inputs:
 *  int ndecks
 * returns:
 * Deck *
 * remarks
 *   create a new deck of cards, with n decks
 ****************************************************************/

Deck * new_deck(int ndecks)
{
  Deck *newdeck;
  int i,d;

  newdeck = (Deck *)calloc(1, sizeof(Deck));

  newdeck->ncards = ( ndecks * 52 );
  newdeck->n = (ndecks*52)-1;

  for (d = 0; d < ndecks; d++) 
    {
      for (i = 0; i < 52; i++)
	{
	  newdeck->cards[(d*52)+i] = baseDeck.cards[i];
	}
    }

  return newdeck;

};




/****************************************************************
 * Name:	shuffle_deck
 * purpose:	Shuffle a deck of cards
 * inputs:
 * Deck *deck 
 * returns:
 *  
 * remarks
 *  Shuffles in place.
 ****************************************************************/

void shuffle_deck(Deck *deck)
{
  int i;
  int j,k;
  Card c;
  
  int ncards = deck->ncards;

  for (i = 0; i < (10 * deck->ncards); i++)
    {
      /* swap two cards at random */
      j = (random() % ncards);
      k = (random() % ncards);
      c = deck->cards[j];
      deck->cards[j] = deck->cards[k];
      deck->cards[k] = c;
    }


  /* start at the top of the deck */
  deck->n = (deck->ncards - 1);

}



/****************************************************************
 * name:	deal_card
 * purpose:	Deals a card off of a deck to a player's hand.
 * inputs:
 *  Deck *deck   a deck of cards
 * returns:
 *   a Card 
 * remarks
 ****************************************************************/
Card deal_card ( Hand *hand, Deck *deck) 
{
  Card c;
  if (deck->n == 0) 
    {
      deck->shuffled = 1;
      shuffle_deck(deck);
    }

  c = deck->cards[(deck->n)--];

  hand->cards[hand->ncards++] = c;
  return c;
}


/****************************************************************
 * name:	has_ace
 * purpose:	see if one or more aces are in a player's hand
 * inputs:
 *  Hand *hand
 * returns:
 *  1 if true, 0 otherwise
 * remarks
 ****************************************************************/

int has_ace(Hand *hand)
{
  int i;

  for ( i = 0; i < hand->ncards; i++)
    {
      if (hand->cards[i].val == ACE) return (1);
    }
  
  return 0;

}



/****************************************************************
 * name:	evaluate_hand
 * purpose:	Find the best possible value of the hand. This means
 *              check if toggling an ace value from 1 to 11 will help. 
 * inputs:
 * Hand *hand
 * returns:
 *
 * remarks
 *  Sets the hand state to BUST if the total is over a hard 21.  
 ****************************************************************/
void evaluate_hand (Hand *hand)
{
  int n;

  hand->softvalue = 0;
  hand->value     = 0;

  for (n = 0; n < hand->ncards; n++) 
    {
      hand->value += card_value_hard(hand->cards[n]);
    }

  /* If the player has a hard 22 or more, they're bust. */
  if (hand->value > 21) 
    {
      hand->state = BUST;
      return;
    }

#ifdef BLACKJACK_FAVOR

  /* If the player has a hard 21, they can't have blackjack.
     However, as a favor, we will not let them hit any further. */

  if (hand->value == 21)
    {
      hand->state = CLOSED;
      hand->value = 21;
      return;
    }

#endif

  /* If the player has an ace, try toggling it to eleven to see if 
     that helps their hand. */
  
  if (has_ace(hand)) 
    {

      /* The soft value is under 21, so use it. */
      if (hand->value+10 <= 21)
	{
	  hand->softvalue  = hand->value;
	  hand->value     += 10;
	}

      if (hand->value == 21)
	{

#ifdef BLACKJACK_FAVOR
	  if (hand->ncards == 2) hand->state = BLACKJACK;
	  else                   hand->state = CLOSED;
#else
	  if (hand->ncards == 2) hand->state = BLACKJACK;
#endif

	}
    }
}

/****************************************************************/



Card makecard(Value val, Suit suit)
{
  Card card = { val, suit };
  return card;
}

/****************************************************************
 * name:	card_value_hard
 * purpose:	Return the hard numeric value of a card
 * inputs:
 * Card card
 * returns:
 *
 * remarks
 ****************************************************************/

int card_value_hard (Card card)
{
  switch (card.val) {
  case ACE: 
    return(1);
    break;
  case TWO: 
    return(2);
    break;
  case THREE: 
    return(3);
    break;
  case FOUR: 
    return(4);
    break;
  case FIVE: 
    return(5);
    break;
  case SIX: 
    return(6);
    break;
  case SEVEN: 
    return(7);
    break;
  case EIGHT: 
    return(8);
    break;
  case NINE: 
    return(9);
    break;
  case TEN: 
    return(10);
    break;
  case JACK: 
    return(10);
    break;
  case QUEEN: 
    return(10);
    break;
  case KING: 
    return(10);
    break;
  default:
    return (0);
    break;
  }
  
}

/****************************************************************
 * name:	card_value_soft
 * purpose:	Return the soft numeric value of a card
 * inputs:
 * Card card
 * returns:
 *
 * remarks
 ****************************************************************/

int card_value_soft (Card card)
{
  int n = card_value_hard (card);

  if (card.val == ACE)
    {
      return(11);
    } 
  else
    {
      return n;
    }
}

/****************************************************************
 * name:	init_hand
 * purpose:	initialize a player hand
 * inputs:
 * Hand *h
 * int bet
 * returns:
 *
 * remarks
 ****************************************************************/

void init_hand(Hand *h, int bet)
{
  h->state = IN_PLAY;
  h->aux = IN_PLAY;
  h->move = IDLE;
  h->value = 0;
  h->ncards = 0;
  h->insurance = 0;
  h->bet = bet;
}

/****************************************************************
 * name:	parse_hand
 * purpose:	Parse a line which encodes a players hand
 * inputs:
 *  Player *p;
 *  char *line
 * returns:
 * remarks

 *  <seqnum> <options> <bet> <balance> [ <dealer_up_card> <HAND> [<HAND>]]
* HAND := [ <state> <move>  <insurance>  <card> <card> ]
 * <state> := IN_PLAY, BUST, CLOSED, WON, LOST, PUSH, BLACKJACK, DOUBLED
 * <card> := A, 1 2 3 4 5 6 7 8 9 T J Q K [HDCS] i.e., AH, KD 3S... 
 
 *  A player can have multiple hands, separated by the "_" character. 
 * SEQNUM CARDS_DEALT SEED AH 1000 IN_PLAY STAND 10 0 3D 7S 8S _ IN_PLAY SPLIT 10 0 9D 9S 
 ****************************************************************/

void parse_hand(Player *p, char *line)
{
  Hand *h, *dh;
  char *token, *card;
  char sep[] = " \t:";

  token = strtok(line, sep);
  /* Get sequence number  field */
  if (!token) 
    {
      fprintf(stderr, "Got NULL string when parsing hand: %s\n", line);
      exit(1);
    }
  p->options = strdup(token);

  /* Get player's options */
  if ((token = strtok(NULL, sep)) == NULL)
    {
      fprintf(stderr, "Problem parsing query string, NULL seqnum\n");
      exit(1);
    }
  else
    {
      p->seqnum = atoi(token);

    }

  
  /* Get the number of cards dealt */
  if ((token = strtok(NULL, sep)) == NULL)
    {
      fprintf(stderr, "Problem parsing query string, NULL ndealt\n");
      exit(1);
    }
  else
    {
      p->ndealt = atoi(token);
    }



  /* Get the shoe random seed value */
  if ((token = strtok(NULL, sep)) == NULL)
    {
      fprintf(stderr, "Problem parsing query string, NULL seed\n");
      exit(1);
    }
  else
    {
      p->seed = atoi(token);
    }

  /* Get player's bet */
  if ((token = strtok(NULL, sep)) == NULL)
    {
      fprintf(stderr, "Problem parsing query string, NULL bet\n");
      exit(1);
    }
  else
    {
      p->bet = atoi(token);
    }


  /* Get balance */
  if ((token = strtok(NULL, sep)) != NULL)
    {
      p->balance = atoi(token);
      p->orig_balance = p->balance;
    }


  /* Get dealer upcard */
  card = strtok(NULL, sep);

  if (card == NULL) 
    {
      /* Player just wants a new game, but old carry balance forward */
      return;
    }
  else
    {
      p->dealer_upcard = parse_card(card);

      /* Start the hand with the dealer upcard. */
      dealer.nhands = 1;
      dh = &(dealer.hands[0]);

      init_hand(dh,0);

      dh->ncards = 1;
      dh->cards[0] = p->dealer_upcard;

    }

  /* Get dealer holecard */
  card = strtok(NULL, sep);

  if (card == NULL) 
    {
      fprintf(stderr, "Problem parsing query string, NULL holecard\n");
      exit(1);
    }
  else
    {
      p->dealer_holecard = parse_card(card);
    }

  while (TRUE) {

    /* Get hand state */
    if (!(token = strtok(NULL, sep))) break;
    
    /* Start parsing the first hand */
    h = &(p->hands[p->nhands]);
    init_hand (h,0);
    p->nhands++;

    h->state = name2state(token);

    /* Get hand's aux state */
    if (!(token = strtok(NULL, sep))) break;
    h->aux = name2state(token);

    /* Get player's move */
    if (!(token = strtok(NULL, sep))) break;
    h->move = name2move(token);

    /* Get bet */
    if (!(token = strtok(NULL, sep))) break;
    h->bet = atoi(token);

    /* Get insurance flag */
    if (!(token = strtok(NULL, sep))) break;
    h->insurance = atoi(token);

    while ( (card = strtok( NULL, sep) ) != NULL) 
      {
	/* If we hit a hand separator, start a new hand */
	if (card[0] == '_') break;

	h->cards[h->ncards++] = parse_card( card );
      }
  }
}


/****************************************************************
 * name:	format_hands
 * purpose:	format a players hands as a string 
 * inputs:
 *  -  Player *p
 *  - FILE *outstream
 * returns:
 *
 * remarks
 ****************************************************************/
void format_hands(Player *p, FILE *out)
{
  
  int i;

  fprintf(out, "%s@", p->options);

  fprintf(out, "%d@", p->seqnum);

  fprintf(out, "%d@", theDeck->ncards - (theDeck->n + 1));

  fprintf(out, "%d@", p->seed);

  fprintf(out, "%d@", p->bet);

  fprintf(out, "%d@", p->balance);

  /* Get dealer upcard */
  fprintf(out, "%s@", format_card(p->dealer_upcard));

  fprintf(out, "%s@", format_card(p->dealer_holecard));

  for (i = 0; i < p->nhands; i++) 
    {
      print_hand(p->hands[i], out);
      /* If we are not at the last hand, print a separator. */
      if (i < (p->nhands - 1))
	fprintf(out, "_@");
    }
}

/****************************************************************
 * name:	print_hand
 * purpose:	
 * inputs:
 *  - Hand h
 *  - FILE *out
 * returns:
 *
 * remarks
 *  Formats a hand as 
 *
 *  <state> <aux> <move> <bet>  <insurance> <dealer_up_card> <card> <card> 
 * <state> := IN_PLAY, BUST, CLOSED, WON, LOST, PUSH, BLACKJACK
 * <aux> := <state>
 * <card> := A, 1 2 3 4 5 6 7 8 9 T J Q K [HDCS] i.e., AH, KD 3S... 
 * 
 *  A player can have multiple hands, separated by the "_" character. 
 * IN_PLAY STAND 10 0 AH 3D 7S 8S _ IN_PLAY SPLIT 10 0 AH 9D 9S 
 * 
 ****************************************************************/

void print_hand ( Hand h, FILE *out)
{
  int i;
      
  /* Get hand state */
  fprintf(out, "%s@", state2name(h.state));


  /* Get hand auxiliary state */
  fprintf(out, "%s@", state2name(h.aux));

  /* Get player's move */
  fprintf(out, "%s@", move2name(h.move));

  /* Get hand bet */
  fprintf(out, "%d@", h.bet);
     
  /* Get insurance flag */
  fprintf(out, "%d@", h.insurance);

  for (i = 0; i < h.ncards ; i++) 
    {
      fprintf(out, "%s@", format_card(h.cards[i]));      
    }
}

/****************************************************************
 * name:	format_card
 * purpose:	
 * inputs:
 * Card c
 * returns:
 * char * str  A string (two char) representation of the card
 * remarks
 ****************************************************************/

char
*format_card(Card c)
{
  char *str = calloc(1, 3);
  str[0] = value2char (c.val);
  str[1] = suit2char (c.suit);
  str[2] = 0;
  return str;
}

/****************************************************************
 * name:	card_inline_image
 * purpose:	returns a string which invokes the inline image for a card.
 * inputs:
 *  Card c
 * returns:
 * char * html
 * remarks
 ****************************************************************/
char * card_inline_image(Card c)
{
  char str[256];
  sprintf(str, "<IMG SRC=\"%s/%s.gif\" WIDTH=%d HEIGHT=%d>",
	  CARDS_URL, format_card(c), CardImageWidth, CardImageHeight);
  return (strdup (str));
}


/****************************************************************
 * name:	parse_card
 * purpose:	
 * inputs:
 * char *token
 * returns:
 * Card 
 * remarks
 ****************************************************************/
Card parse_card(char *token)
{
  Card c;
  c.val = char2value(token[0]);
  c.suit = lookup_cardsuit(token[1]);
  return c;
}

Suit lookup_cardsuit(char c)
{
  c = tolower(c);

  switch (c) {
  case 'h':
    return(HEARTS);
    break;
  case 'c':
    return(CLUBS);
    break;
  case 'd':
    return(DIAMONDS);
    break;
  case 's':
    return(SPADES);
    break;
  default:
    return(CLUBS);
  }
}

/****************************************************************
 * All of these functions ought to be simple hash table lookups...
 *
 */

char *state2name(State s)
{
  int i;
  for (i = 0; i < sizeof(state_name_table)/sizeof(StateMap); i++) 
    {
      if (s == state_name_table[i].state)
	{
	  return state_name_table[i].name;
	}
    }
  fprintf(stderr, "State name not found %d/n", s);
  return("IN_PLAY");
}


char *state2pretty_name(State s)
{
  int i;
  for (i = 0; i < sizeof(pretty_state_name_table)/sizeof(StateMap); i++) 
    {
      if (s == pretty_state_name_table[i].state)
	{
	  return pretty_state_name_table[i].name;
	}
    }
  fprintf(stderr, "State name not found %d/n", s);
  return("____");
}

State name2state(char *name)
{
  int i;
  for (i = 0; i < sizeof(state_name_table)/sizeof(StateMap); i++) 
    {
      if (!(strcmp(name, state_name_table[i].name)))
	{
	  return state_name_table[i].state;
	}
    }
  /* we should never reach here, but makes compiler happy */
  fprintf(stderr, "State name not found %s/n", name);
  return (IN_PLAY);
}


char *move2name(Move s)
{
  int i;
  for (i = 0; i < sizeof(move_name_table)/sizeof(MoveMap); i++) 
    {
      if (s == move_name_table[i].move)
	{
	  return move_name_table[i].name;
	}
    }
  fprintf(stderr, "Move name not found %d/n", s);
  return("IDLE");
}

Move name2move(char *name)
{
  int i;
  for (i = 0; i < sizeof(move_name_table)/sizeof(MoveMap); i++) 
    {
      if (!(strcmp(name, move_name_table[i].name)))
	{
	  return move_name_table[i].move;
	}
    }
  fprintf(stderr, "Move name not found %s/n", name);
  return (IDLE);
}

/****************************************************************/

char suit2char (Suit s)
{
  int i;
  for (i = 0; i < sizeof(suit_name_table)/sizeof(SuitMap); i++) 
    {
      if (s == suit_name_table[i].s)
	{
	  return suit_name_table[i].c;
	}
    }
  fprintf(stderr, "Suit name not found %d/n", s);
  return('X');
}


char value2char (Value s)
{
  int i;
  for (i = 0; i < sizeof(value_name_table)/sizeof(ValueMap); i++) 
    {
      if (s == value_name_table[i].val)
	{
	  return value_name_table[i].c;
	}
    }
  fprintf(stderr, "Value name not found %d/n", s);
  return('X');
}


Value char2value (char c)
{
  int i;
  for (i = 0; i < sizeof(value_name_table)/sizeof(ValueMap); i++) 
    {
      if (c == value_name_table[i].c)
	{
	  return value_name_table[i].val;
	}
    }
  fprintf(stderr, "Value name not found %c/n", c);
  return(_NOVAL_);
}


void spacetoplus(char *str)
{
  int x;

  for(x=0;str[x];x++) if(str[x] == ' ') str[x] = SEPCHAR;
}

/****************************************************************/
char
*pretty_format_card(Card c)
{
  char str[256];
  char *suit, *val;

  switch (c.val)
    {
    case ACE:
      val = "A";
      break;
    case TWO:
      val = "2";
      break;
    case THREE:
      val = "3";
      break;
    case FOUR:
      val = "4";
      break;
    case FIVE:
      val = "5";
      break;
    case SIX:
      val = "6";
      break;
    case SEVEN:
      val = "7";
      break;
    case EIGHT:
      val = "8";
      break;
    case NINE:
      val = "9";
      break;
    case TEN:
      val = "10";
      break;
    case JACK:
      val = "J";
      break;
    case QUEEN:
      val = "Q";
      break;
    case KING:
      val = "K";
      break;
    default:
      val = "X";
      break;
    }
  
  switch (c.suit)
    {
    case CLUBS:
      suit = "Clubs";
      break;

    case DIAMONDS:
      suit = "Diamonds";
      break;

    case HEARTS:
      suit = "Hearts";
      break;

    case SPADES:
      suit = "Spades";
      break;

    default:
      suit = "xxxx";
      break;
    }

  sprintf(str, "<B>%s</B> of %s", val, suit);
  return(strdup(str));

};

/****************************************************************
 * $Log: bjcount.c,v $
 * Revision 1.7  1996/01/18 05:14:45  baccala
 * Changed for FreeSoft Web page - new BJ_URL, new page trailer
 *
 * Revision 1.6  1995/12/02 04:29:48  baccala
 * Added basic strategy check - audio error indication
 *
 * Revision 1.5  1995/12/02 00:26:46  baccala
 * Moved bet area to right of dealer cards
 *
 * Dealer now takes a holecard (BUT IT'S IN THE URL!) and checks for BJ
 *   No insurance yet
 *
 * Revision 1.4  1995/12/01 22:42:53  baccala
 * Added imaage scaling via global define ImageScale
 *
 * Revision 1.3  1995/12/01 21:51:35  baccala
 * Got rid of gcc warning messages
 *
 * Revision 1.2  1995/11/29 02:56:01  baccala
 * Brent's first set of mods -
 *    Layout done with <TABLE> </TABLE>
 *    GIFs added for chips
 *
 * Revision 1.19  1994/12/23  00:19:49  hqm
 * in evaluate_final_hand. if the player has blackjack,
 * leave the hand state as BLACKJACK, rather than setting it to "WIN"
 *
 * Revision 1.18  1994/12/23  00:11:35  hqm
 * fixed bug where if you got blackjack in the opening hand
 * and the dealer subsequently busted, you didn't get 3:2 payoff.
 *
 * Revision 1.17  1994/12/08  04:02:28  hqm
 * Add GPL
 *
 * Revision 1.16  1994/12/08  03:57:40  hqm
 * Report the amount won or lost on this hand.
 *
 * Revision 1.15  1994/12/04  03:38:16  hqm
 * *** empty log message ***
 *
 * Revision 1.14  1994/12/01  08:40:10  hqm
 * make balance boldface
 *
 * Revision 1.13  1994/11/30  07:56:32  hqm
 * user with blackjack was getting paid for WIN rather than BJ
 *
 * Revision 1.12  1994/11/30  04:33:41  hqm
 * fixed bug which prevented payoff of blackjack to winning hand.
 *
 * Revision 1.11  1994/11/30  02:11:35  hqm
 * Make user state be PUSH on push final eval
 *
 * Revision 1.10  1994/11/29  05:19:45  hqm
 * format split and double options with commas
 *
 * Revision 1.9  1994/11/29  05:10:41  hqm
 * add dealer hand inline images
 *
 * Revision 1.8  1994/11/28  22:49:22  hqm
 * fixed bug in valuing hands with an ace
 *
 * Revision 1.7  1994/11/28  22:40:30  hqm
 * allow doublling on first two cards.
 *
 * Revision 1.6  1994/11/28  21:06:59  hqm
 * *** empty log message ***
 *
 * Revision 1.5  1994/11/28  20:46:21  hqm
 * *** empty log message ***
 *
 * Revision 1.4  1994/11/28  20:37:29  hqm
 * *** empty log message ***
 *
 * Revision 1.3  1994/11/28  20:31:28  hqm
 * don't get screwed by no backup files...
 *
 * Revision 1.2  1994/11/28  06:09:57  hqm
 * added doubling
 *
 *
 */
